#ifndef ORDER_HH
#define ORDER_HH

namespace Interval {
    class Order;
}

class Interval::Order {
private:
    long count_;
    long max_;
public:
    inline long count() const { return count_; }
    inline long max  () const { return max_  ; } // -1 means no maximum
    inline Order &reset();
    inline long increment(long);
    inline explicit Order(long max1 = -1);
};

Interval::Order &Interval::Order::reset()
{ count_ = 0; return *this; }

long Interval::Order::increment(const long i)
{ return count_ += i; }

Interval::Order::Order(const long max1): count_ {0}, max_ {max1}
{}

#endif

