#include "printout.hh"
#include "stringific.hh"

void Driver::printout(
    const mp_bitcnt_t precision, const Interval::Lohi &n,
    const std::list<Facet_to_print> &facets,
    const long order_count, std::ostream &os
)
{
    for (Facet_to_print facet: facets) {
        mpz_class m;
        switch (facet) {
        case Facet_to_print::lo   : m = n.lo()            ; break;
        case Facet_to_print::hi   : m = n.hi()            ; break;
        case Facet_to_print::delta: m = Interval::delta(n); break;
        case Facet_to_print::mid  : m = Interval::mid  (n); break;
        case Facet_to_print::dev  : m = Interval::dev  (n); break;
        case Facet_to_print::prec :
        case Facet_to_print::order:
            m = 0;
            break;
        default: throw Driver::Impossibility {};
        }
        if (facet == Facet_to_print::prec) {
            os << Interval::stringify
            (0, precision, Interval::Stringify_style::integer);
        }
        else if (facet == Facet_to_print::order) {
            os << Interval::stringify
            (0, order_count, Interval::Stringify_style::integer);
        }
        else os << Interval::stringify(precision, m);
    }
}

