#include "twopi.hh"
#include "roots.hh"

Interval::Lohi Interval::calc_twopi
  (const mp_bitcnt_t precision, Order *const ptr_order)
{
    Prelohi result {0};
    const Lohi decay
      {root(Indicant_re_general_quadratic(precision, 3, 4, -7, 1))};
    Lohi preaddend
      {root(Indicant_re_general_quadratic(precision, 3, -0x18, 0x30, 1))};
    if (decay.hi() > 0 || preaddend.lo() < 0) throw Domain_straddle {};
    Lohi quarry {0};
    const long order_max {
        ptr_order->max() <  0 ? -1 :
        ptr_order->max() == 0 ?  1 :
        ptr_order->max() &  1 ? ptr_order->max() : ptr_order->max() - 1
    };
    for (ptr_order->reset().increment(1);; ptr_order->increment(2)) {
        quarry += preaddend / ptr_order->count();
        if (ptr_order->count() & 2) {
            if (quarry.lo() <= result.lo())
              { ptr_order->increment(-2); break; }
            result.lo() = quarry.lo();
        }
        else {
            if (quarry.hi() >= result.hi() && ptr_order->count() > 1)
              { ptr_order->increment(-2); break; }
            result.hi() = quarry.hi();
        }
        if (order_max >= 0 && ptr_order->count() >= order_max) break;
        preaddend *= decay;
        preaddend >>= precision;
    }
    return result;
}

Interval::Lohi Interval::calc_sqrttwopi
  (const mp_bitcnt_t precision, Order *const ptr_order)
{
    const Lohi twopi {calc_twopi(precision, ptr_order)};
    if (twopi.lo() <= 0) throw Domain_straddle {};
    return root(precision, 1, 2, twopi);
}

