#include "../../src/roots.hh"
#include <cassert>
//#include <iostream>
//#include <iomanip>

int main()
{

    Interval::Lohi x;

    x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 0, 14,  3)); assert (x.lo() == 0x4aaaa && x.hi() == 0x4aaab);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 0, 29,  8)); assert (x.lo() == 0x3a000 && x.hi() == 0x3a000);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2, 29,  8)); assert (x.lo() == 0x40ed9 && x.hi() == 0x40eda);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3,-2, 29,  8)); assert (x.lo() == 0x33126 && x.hi() == 0x33127);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3,-2,-29,  8)); assert (x.hi() ==-0x40ed9 && x.lo() ==-0x40eda);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2,-29,  8)); assert (x.hi() ==-0x33126 && x.lo() ==-0x33127);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2,-29,  8, true)); assert (x.hi() ==-0x40ed9 && x.lo() ==-0x40eda);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3,-2,-29,  8, true)); assert (x.hi() ==-0x33126 && x.lo() ==-0x33127);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3,-2, 29,  8, true)); assert (x.lo() == 0x40ed9 && x.hi() == 0x40eda);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2, 29,  8, true)); assert (x.lo() == 0x33126 && x.hi() == 0x33127);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2, 29, -8)); assert (x.hi() ==-0x40ed9 && x.lo() ==-0x40eda);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3,-2, 29, -8)); assert (x.hi() ==-0x33126 && x.lo() ==-0x33127);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3,-2,-29, -8)); assert (x.lo() == 0x40ed9 && x.hi() == 0x40eda);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2,-29, -8)); assert (x.lo() == 0x33126 && x.hi() == 0x33127);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 4, 2,  8,  2)); assert (x.lo() == 0x60000 && x.hi() == 0x60000);
    x = root(Interval::Indicant_re_general_quadratic(   2, 1, 1, 10, 16)); assert (x.lo() ==       2 && x.hi() ==       3);
    x = root(Interval::Indicant_re_general_quadratic(   2, 1,-1, 10, 16)); assert (x.lo() ==       2 && x.hi() ==       3);
    x = root(Interval::Indicant_re_general_quadratic(   4, 1, 1, 10, 16)); assert (x.lo() ==      11 && x.hi() ==      11);
    x = root(Interval::Indicant_re_general_quadratic(   4, 1,-1, 10, 16)); assert (x.lo() ==       9 && x.hi() ==       9);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 4, 1,  0,  2)); assert (x.lo() == 0x10000 && x.hi() == 0x10000);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 4, 1,  0,  1)); assert (x.lo() == 0x20000 && x.hi() == 0x20000);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 0, 1,  1,  2)); assert (x.lo() == 0x08000 && x.hi() == 0x08000);
    x = root(Interval::Indicant_re_general_quadratic(0x10, 4, 0,  1,  2)); assert (x.lo() == 0x08000 && x.hi() == 0x08000);
    {
        int n_error {0};
        try { x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 0, 14,  3)); } catch (const Interval::Forbidden_negative) {++n_error;}
        try { x = root(Interval::Indicant_re_general_quadratic(   0, 3, 0, 14,  3)); } catch (const Interval::Forbidden_negative) {++n_error;}
        try { x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2, 14,  3)); } catch (const Interval::Forbidden_negative) {++n_error;}
        try { x = root(Interval::Indicant_re_general_quadratic(0x10, 0, 2, 14,  3)); } catch (const Interval::Forbidden_negative) {++n_error;}
        try { x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2, 14, -3)); } catch (const Interval::Forbidden_negative) {++n_error;}
        try { x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2,-14,  3)); } catch (const Interval::Forbidden_negative) {++n_error;}
        try { x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2,  0,  3)); } catch (const Interval::Forbidden_negative) {++n_error;}
        assert(!n_error);
        try { x = root(Interval::Indicant_re_general_quadratic(0x10, 3, 2, 14,  0)); } catch (const Interval::Division_by_zero) {++n_error;}
        assert(n_error == 1);
        try { x = root(Interval::Indicant_re_general_quadratic(0x10,-3, 2, 14,  3)); } catch (const Interval::Forbidden_negative) {++n_error;}
        assert(n_error == 2);
    }
    x = root(Interval::Indicant_re_power(0x10,  1,  3,  5,  1)); assert (x.lo() ==  0x1b5c0 && x.hi() ==  0x1b5c1);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  5,  1)); assert (x.lo() ==  0x2ec8c && x.hi() ==  0x2ec8d);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  8,  1)); assert (x.lo() ==  0x40000 && x.hi() ==  0x40000);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  0,  1)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    x = root(Interval::Indicant_re_power(0x10,  2,  3, -8,  1)); assert (x.lo() ==  0x40000 && x.hi() ==  0x40000);
    x = root(Interval::Indicant_re_power(0x10,  1,  2,  1, 32)); assert (x.lo() ==  0x02d41 && x.hi() ==  0x02d42);
    x = root(Interval::Indicant_re_power(0x02,  1,  2,  1, 32)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00001);
    x = root(Interval::Indicant_re_power(0x03,  1,  2,  1, 32)); assert (x.lo() ==  0x00001 && x.hi() ==  0x00002);
    x = root(Interval::Indicant_re_power(0x10,  4,  6,  5,  7)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  5,  7)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2, -3,  5,  7)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10, -2, -3,  5,  7)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10, -2,  3,  5,  7)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  5, -7)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2, -3,  5, -7)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10, -2, -3,  5, -7)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10, -2,  3,  5, -7)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10,  2,  3, -5, -7)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2, -3, -5, -7)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10, -2, -3, -5, -7)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10, -2,  3, -5, -7)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10,  2,  3, -5,  7)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2, -3, -5,  7)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10, -2, -3, -5,  7)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10, -2,  3, -5,  7)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10,  3,  2,  5,  7)); assert (x.lo() ==  0x09a8a && x.hi() ==  0x09a8b);
    x = root(Interval::Indicant_re_power(0x10,  3, -2,  5,  7)); assert (x.lo() ==  0x1a810 && x.hi() ==  0x1a811);
    x = root(Interval::Indicant_re_power(0x10, -3, -2,  5,  7)); assert (x.lo() ==  0x09a8a && x.hi() ==  0x09a8b);
    x = root(Interval::Indicant_re_power(0x10, -3,  2,  5,  7)); assert (x.lo() ==  0x1a810 && x.hi() ==  0x1a811);
    x = root(Interval::Indicant_re_power(0x10,  3,  2, -5, -7)); assert (x.hi() ==  0x09a8b && x.lo() ==  0x09a8a);
    x = root(Interval::Indicant_re_power(0x10,  3, -2, -5, -7)); assert (x.hi() ==  0x1a811 && x.lo() ==  0x1a810);
    x = root(Interval::Indicant_re_power(0x10, -3, -2, -5, -7)); assert (x.hi() ==  0x09a8b && x.lo() ==  0x09a8a);
    x = root(Interval::Indicant_re_power(0x10, -3,  2, -5, -7)); assert (x.hi() ==  0x1a811 && x.lo() ==  0x1a810);
    x = root(Interval::Indicant_re_power(0x10,  3,  5,  5,  7)); assert (x.lo() ==  0x0d133 && x.hi() ==  0x0d134);
    x = root(Interval::Indicant_re_power(0x10,  3, -5,  5,  7)); assert (x.lo() ==  0x13944 && x.hi() ==  0x13945);
    x = root(Interval::Indicant_re_power(0x10, -3, -5,  5,  7)); assert (x.lo() ==  0x0d133 && x.hi() ==  0x0d134);
    x = root(Interval::Indicant_re_power(0x10, -3,  5,  5,  7)); assert (x.lo() ==  0x13944 && x.hi() ==  0x13945);
    x = root(Interval::Indicant_re_power(0x10,  3,  5,  5, -7)); assert (x.lo() == -0x0d134 && x.hi() == -0x0d133);
    x = root(Interval::Indicant_re_power(0x10,  3, -5,  5, -7)); assert (x.lo() == -0x13945 && x.hi() == -0x13944);
    x = root(Interval::Indicant_re_power(0x10, -3, -5,  5, -7)); assert (x.lo() == -0x0d134 && x.hi() == -0x0d133);
    x = root(Interval::Indicant_re_power(0x10, -3,  5,  5, -7)); assert (x.lo() == -0x13945 && x.hi() == -0x13944);
    x = root(Interval::Indicant_re_power(0x10,  3,  5, -5, -7)); assert (x.lo() ==  0x0d133 && x.hi() ==  0x0d134);
    x = root(Interval::Indicant_re_power(0x10,  3, -5, -5, -7)); assert (x.lo() ==  0x13944 && x.hi() ==  0x13945);
    x = root(Interval::Indicant_re_power(0x10, -3, -5, -5, -7)); assert (x.lo() ==  0x0d133 && x.hi() ==  0x0d134);
    x = root(Interval::Indicant_re_power(0x10, -3,  5, -5, -7)); assert (x.lo() ==  0x13944 && x.hi() ==  0x13945);
    x = root(Interval::Indicant_re_power(0x10,  3,  5, -5,  7)); assert (x.lo() == -0x0d134 && x.hi() == -0x0d133);
    x = root(Interval::Indicant_re_power(0x10,  3, -5, -5,  7)); assert (x.lo() == -0x13945 && x.hi() == -0x13944);
    x = root(Interval::Indicant_re_power(0x10, -3, -5, -5,  7)); assert (x.lo() == -0x0d134 && x.hi() == -0x0d133);
    x = root(Interval::Indicant_re_power(0x10, -3,  5, -5,  7)); assert (x.lo() == -0x13945 && x.hi() == -0x13944);
    {
        int n_error {0};
        try { x = root(Interval::Indicant_re_power(0x10,  3,  2,  5, -7)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10,  3, -2,  5, -7)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -3, -2,  5, -7)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -3,  2,  5, -7)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10,  3,  2, -5,  7)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10,  3, -2, -5,  7)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -3, -2, -5,  7)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -3,  2, -5,  7)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        assert(n_error == 8);
    }
    {
        int n_error {0};
        try { x = root(Interval::Indicant_re_power(0x10,  2,  0,  5,  7)); } catch (const Interval::Division_by_zero) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10,  2,  3,  5,  0)); } catch (const Interval::Division_by_zero) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -2,  3,  0,  7)); } catch (const Interval::Division_by_zero) { ++n_error; }
        assert(n_error == 3);
    }
    x = root(Interval::Indicant_re_power(0x10,  0,  3,  5,  7)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0, -3,  5,  7)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0,  3,  5, -7)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0, -3,  5, -7)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0,  3, -5, -7)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0, -3, -5, -7)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0,  3, -5,  7)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0, -3, -5,  7)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  0,  7)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    x = root(Interval::Indicant_re_power(0x10, -2, -3,  0,  7)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  0, -7)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    x = root(Interval::Indicant_re_power(0x10, -2, -3,  0, -7)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    {
        int n_error {0};
        try { x = root(Interval::Indicant_re_power(0x10,  0,  1,  0,  1)); } catch (const Interval::Division_by_zero) { ++n_error; }
        assert(n_error == 1);
    }
    x = root(Interval::Indicant_re_power(0x10,  1,  3,  5,  1, true)); assert (x.lo() ==  0x1b5c0 && x.hi() ==  0x1b5c1);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  5,  1, true)); assert (x.lo() ==  0x2ec8c && x.hi() ==  0x2ec8d);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  8,  1, true)); assert (x.lo() ==  0x40000 && x.hi() ==  0x40000);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  0,  1, true)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    x = root(Interval::Indicant_re_power(0x10,  2,  3, -8,  1, true)); assert (x.lo() ==  0x40000 && x.hi() ==  0x40000);
    x = root(Interval::Indicant_re_power(0x10,  1,  2,  1, 32, true)); assert (x.hi() == -0x02d41 && x.lo() == -0x02d42);
    x = root(Interval::Indicant_re_power(0x02,  1,  2,  1, 32, true)); assert (x.hi() == -0x00000 && x.lo() == -0x00001);
    x = root(Interval::Indicant_re_power(0x03,  1,  2,  1, 32, true)); assert (x.hi() == -0x00001 && x.lo() == -0x00002);
    x = root(Interval::Indicant_re_power(0x10,  4,  6,  5,  7, true)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  5,  7, true)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2, -3,  5,  7, true)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10, -2, -3,  5,  7, true)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10, -2,  3,  5,  7, true)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  5, -7, true)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2, -3,  5, -7, true)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10, -2, -3,  5, -7, true)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10, -2,  3,  5, -7, true)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10,  2,  3, -5, -7, true)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2, -3, -5, -7, true)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10, -2, -3, -5, -7, true)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10, -2,  3, -5, -7, true)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10,  2,  3, -5,  7, true)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10,  2, -3, -5,  7, true)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10, -2, -3, -5,  7, true)); assert (x.lo() ==  0x0cc8f && x.hi() ==  0x0cc90);
    x = root(Interval::Indicant_re_power(0x10, -2,  3, -5,  7, true)); assert (x.lo() ==  0x14060 && x.hi() ==  0x14061);
    x = root(Interval::Indicant_re_power(0x10,  3,  2,  5,  7, true)); assert (x.hi() == -0x09a8a && x.lo() == -0x09a8b);
    x = root(Interval::Indicant_re_power(0x10,  3, -2,  5,  7, true)); assert (x.hi() == -0x1a810 && x.lo() == -0x1a811);
    x = root(Interval::Indicant_re_power(0x10, -3, -2,  5,  7, true)); assert (x.hi() == -0x09a8a && x.lo() == -0x09a8b);
    x = root(Interval::Indicant_re_power(0x10, -3,  2,  5,  7, true)); assert (x.hi() == -0x1a810 && x.lo() == -0x1a811);
    x = root(Interval::Indicant_re_power(0x10,  3,  2, -5, -7, true)); assert (x.lo() == -0x09a8b && x.hi() == -0x09a8a);
    x = root(Interval::Indicant_re_power(0x10,  3, -2, -5, -7, true)); assert (x.lo() == -0x1a811 && x.hi() == -0x1a810);
    x = root(Interval::Indicant_re_power(0x10, -3, -2, -5, -7, true)); assert (x.lo() == -0x09a8b && x.hi() == -0x09a8a);
    x = root(Interval::Indicant_re_power(0x10, -3,  2, -5, -7, true)); assert (x.lo() == -0x1a811 && x.hi() == -0x1a810);
    x = root(Interval::Indicant_re_power(0x10,  3,  5,  5,  7, true)); assert (x.lo() ==  0x0d133 && x.hi() ==  0x0d134);
    x = root(Interval::Indicant_re_power(0x10,  3, -5,  5,  7, true)); assert (x.lo() ==  0x13944 && x.hi() ==  0x13945);
    x = root(Interval::Indicant_re_power(0x10, -3, -5,  5,  7, true)); assert (x.lo() ==  0x0d133 && x.hi() ==  0x0d134);
    x = root(Interval::Indicant_re_power(0x10, -3,  5,  5,  7, true)); assert (x.lo() ==  0x13944 && x.hi() ==  0x13945);
    x = root(Interval::Indicant_re_power(0x10,  3,  5,  5, -7, true)); assert (x.lo() == -0x0d134 && x.hi() == -0x0d133);
    x = root(Interval::Indicant_re_power(0x10,  3, -5,  5, -7, true)); assert (x.lo() == -0x13945 && x.hi() == -0x13944);
    x = root(Interval::Indicant_re_power(0x10, -3, -5,  5, -7, true)); assert (x.lo() == -0x0d134 && x.hi() == -0x0d133);
    x = root(Interval::Indicant_re_power(0x10, -3,  5,  5, -7, true)); assert (x.lo() == -0x13945 && x.hi() == -0x13944);
    x = root(Interval::Indicant_re_power(0x10,  3,  5, -5, -7, true)); assert (x.lo() ==  0x0d133 && x.hi() ==  0x0d134);
    x = root(Interval::Indicant_re_power(0x10,  3, -5, -5, -7, true)); assert (x.lo() ==  0x13944 && x.hi() ==  0x13945);
    x = root(Interval::Indicant_re_power(0x10, -3, -5, -5, -7, true)); assert (x.lo() ==  0x0d133 && x.hi() ==  0x0d134);
    x = root(Interval::Indicant_re_power(0x10, -3,  5, -5, -7, true)); assert (x.lo() ==  0x13944 && x.hi() ==  0x13945);
    x = root(Interval::Indicant_re_power(0x10,  3,  5, -5,  7, true)); assert (x.lo() == -0x0d134 && x.hi() == -0x0d133);
    x = root(Interval::Indicant_re_power(0x10,  3, -5, -5,  7, true)); assert (x.lo() == -0x13945 && x.hi() == -0x13944);
    x = root(Interval::Indicant_re_power(0x10, -3, -5, -5,  7, true)); assert (x.lo() == -0x0d134 && x.hi() == -0x0d133);
    x = root(Interval::Indicant_re_power(0x10, -3,  5, -5,  7, true)); assert (x.lo() == -0x13945 && x.hi() == -0x13944);
    {
        int n_error {0};
        try { x = root(Interval::Indicant_re_power(0x10,  3,  2,  5, -7, true)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10,  3, -2,  5, -7, true)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -3, -2,  5, -7, true)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -3,  2,  5, -7, true)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10,  3,  2, -5,  7, true)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10,  3, -2, -5,  7, true)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -3, -2, -5,  7, true)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -3,  2, -5,  7, true)); } catch (const Interval::Forbidden_negative) { ++n_error; }
        assert(n_error == 8);
    }
    {
        int n_error {0};
        try { x = root(Interval::Indicant_re_power(0x10,  2,  0,  5,  7, true)); } catch (const Interval::Division_by_zero) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10,  2,  3,  5,  0, true)); } catch (const Interval::Division_by_zero) { ++n_error; }
        try { x = root(Interval::Indicant_re_power(0x10, -2,  3,  0,  7, true)); } catch (const Interval::Division_by_zero) { ++n_error; }
        assert(n_error == 3);
    }
    x = root(Interval::Indicant_re_power(0x10,  0,  3,  5,  7, true)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0, -3,  5,  7, true)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0,  3,  5, -7, true)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0, -3,  5, -7, true)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0,  3, -5, -7, true)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0, -3, -5, -7, true)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0,  3, -5,  7, true)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  0, -3, -5,  7, true)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  0,  7, true)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    x = root(Interval::Indicant_re_power(0x10, -2, -3,  0,  7, true)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    x = root(Interval::Indicant_re_power(0x10,  2,  3,  0, -7, true)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    x = root(Interval::Indicant_re_power(0x10, -2, -3,  0, -7, true)); assert (x.lo() ==  0x00000 && x.hi() ==  0x00000);
    {
        int n_error {0};
        try { x = root(Interval::Indicant_re_power(0x10,  0,  1,  0,  1, true)); } catch (const Interval::Division_by_zero) { ++n_error; }
        assert(n_error == 1);
    }
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 4,   0x2d439)); assert (x.lo() >=  0x2d437 && x.hi() <=  0x2d43b);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 4,   0x2d439)); assert (x.lo() >=  0x22e6b && x.hi() <=  0x22e6f);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 3,   0x2d439)); assert (x.lo() >=  0x40044 && x.hi() <=  0x40048);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 5,   0x2d439)); assert (x.lo() >=  0x1ddc3 && x.hi() <=  0x1ddc7);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  5, 3,   0x2d439)); assert (x.lo() >=  0x5a8a2 && x.hi() <=  0x5a8a6);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 4,   0x2d439)); assert (x.lo() >=  0x05a7c && x.hi() <=  0x05a80);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 4,   0x2d439)); assert (x.lo() >=  0x0755a && x.hi() <=  0x0755e);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 3,   0x2d439)); assert (x.lo() >=  0x03ffa && x.hi() <=  0x03ffe);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 5,   0x2d439)); assert (x.lo() >=  0x0892a && x.hi() <=  0x0892e);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -5, 3,   0x2d439)); assert (x.lo() >=  0x02d3b && x.hi() <=  0x02d3f);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 4,  -0x2d439)); assert (x.hi() <= -0x2d437 && x.lo() >= -0x2d43b);
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 4,  -0x2d439)); } catch (const Interval::Forbidden_negative) { has_caught = true; } assert(has_caught); }
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 3,  -0x2d439)); assert (x.lo() >=  0x40044 && x.hi() <=  0x40048);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 5,  -0x2d439)); assert (x.hi() <= -0x1ddc3 && x.lo() >= -0x1ddc7);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  5, 3,  -0x2d439)); assert (x.hi() <= -0x5a8a2 && x.lo() >= -0x5a8a6);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 4,  -0x2d439)); assert (x.hi() <= -0x05a7c && x.lo() >= -0x05a80);
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 4,  -0x2d439)); } catch (const Interval::Forbidden_negative) { has_caught = true; } assert(has_caught); }
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 3,  -0x2d439)); assert (x.lo() >=  0x03ffa && x.hi() <=  0x03ffe);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 5,  -0x2d439)); assert (x.hi() <= -0x0892a && x.lo() >= -0x0892e);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -5, 3,  -0x2d439)); assert (x.hi() <= -0x02d3b && x.lo() >= -0x02d3f);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 4,         0)); assert (x.lo() ==        0 && x.hi() ==        0);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 4,         0)); assert (x.lo() ==        0 && x.hi() ==        0);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 3,         0)); assert (x.lo() ==        0 && x.hi() ==        0);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 5,         0)); assert (x.lo() ==        0 && x.hi() ==        0);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  5, 3,         0)); assert (x.lo() ==        0 && x.hi() ==        0);
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 4,         0)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 4,         0)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 3,         0)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 5,         0)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -5, 3,         0)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10,  0, 1,         0)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  0, 1,   0x2d439)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  0, 1,  -0x2d439)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  1, 2,  0x400000)); assert (x.lo() ==  0x80000 && x.hi() ==  0x80000);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 4,   0x2d439, true)); assert (x.lo() >=  0x2d437 && x.hi() <=  0x2d43b);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 4,   0x2d439, true)); assert (x.hi() <= -0x22e6b && x.lo() >= -0x22e6f);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 3,   0x2d439, true)); assert (x.lo() >=  0x40044 && x.hi() <=  0x40048);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 5,   0x2d439, true)); assert (x.lo() >=  0x1ddc3 && x.hi() <=  0x1ddc7);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  5, 3,   0x2d439, true)); assert (x.lo() >=  0x5a8a2 && x.hi() <=  0x5a8a6);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 4,   0x2d439, true)); assert (x.lo() >=  0x05a7c && x.hi() <=  0x05a80);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 4,   0x2d439, true)); assert (x.hi() <= -0x0755a && x.lo() >= -0x0755e);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 3,   0x2d439, true)); assert (x.lo() >=  0x03ffa && x.hi() <=  0x03ffe);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 5,   0x2d439, true)); assert (x.lo() >=  0x0892a && x.hi() <=  0x0892e);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -5, 3,   0x2d439, true)); assert (x.lo() >=  0x02d3b && x.hi() <=  0x02d3f);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 4,  -0x2d439, true)); assert (x.hi() <= -0x2d437 && x.lo() >= -0x2d43b);
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 4,  -0x2d439, true)); } catch (const Interval::Forbidden_negative) { has_caught = true; } assert(has_caught); }
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 3,  -0x2d439, true)); assert (x.lo() >=  0x40044 && x.hi() <=  0x40048);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 5,  -0x2d439, true)); assert (x.hi() <= -0x1ddc3 && x.lo() >= -0x1ddc7);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  5, 3,  -0x2d439, true)); assert (x.hi() <= -0x5a8a2 && x.lo() >= -0x5a8a6);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 4,  -0x2d439, true)); assert (x.hi() <= -0x05a7c && x.lo() >= -0x05a80);
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 4,  -0x2d439, true)); } catch (const Interval::Forbidden_negative) { has_caught = true; } assert(has_caught); }
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 3,  -0x2d439, true)); assert (x.lo() >=  0x03ffa && x.hi() <=  0x03ffe);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 5,  -0x2d439, true)); assert (x.hi() <= -0x0892a && x.lo() >= -0x0892e);
    x = root(Interval::Indicant_re_irrat_to_power(0x10, -5, 3,  -0x2d439, true)); assert (x.hi() <= -0x02d3b && x.lo() >= -0x02d3f);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 4,         0, true)); assert (x.lo() ==        0 && x.hi() ==        0);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 4,         0, true)); assert (x.lo() ==        0 && x.hi() ==        0);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  4, 3,         0, true)); assert (x.lo() ==        0 && x.hi() ==        0);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  3, 5,         0, true)); assert (x.lo() ==        0 && x.hi() ==        0);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  5, 3,         0, true)); assert (x.lo() ==        0 && x.hi() ==        0);
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 4,         0, true)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 4,         0, true)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -4, 3,         0, true)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -3, 5,         0, true)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10, -5, 3,         0, true)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    { bool has_caught {false}; try { x = root(Interval::Indicant_re_irrat_to_power(0x10,  0, 1,         0, true)); } catch (const Interval::Division_by_zero) { has_caught = true; } assert(has_caught); }
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  0, 1,   0x2d439)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  0, 1,  -0x2d439)); assert (x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(Interval::Indicant_re_irrat_to_power(0x10,  1, 2,  0x400000)); assert (x.lo() ==  0x80000 && x.hi() ==  0x80000);

    // Now test root(mp_bitcnt_t precision, const Lohi &, long n, long m, bool prefer_negative_branch = false), the overloaded root().
    x = root(0x10,  4,  4, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() ==  0x30000 && x.hi() ==  0x50000);
    x = root(0x10,  3,  4, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() >=  0x2478c && x.lo() <=  0x24790 && x.hi() >=  0x357fb && x.hi() <=  0x357ff);
    x = root(0x10,  4,  3, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() >=  0x453a4 && x.lo() <=  0x453a8 && x.hi() >=  0x88cc3 && x.hi() <=  0x88cc7);
    x = root(0x10,  3,  5, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() >=  0x1eee3 && x.lo() <=  0x1eee7 && x.hi() >=  0x2a062 && x.hi() <=  0x2a066);
    x = root(0x10,  5,  3, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() >=  0x63d7f && x.lo() <=  0x63d83 && x.hi() >=  0xe9ebc && x.hi() <=  0xe9ec0);
    x = root(0x10, -4,  4, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() >=  0x03331 && x.lo() <=  0x03335 && x.hi() >=  0x05553 && x.hi() <=  0x05557);
    x = root(0x10, -3,  4, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() >=  0x04c8e && x.lo() <=  0x04c92 && x.hi() >=  0x0704c && x.hi() <=  0x07050);
    x = root(0x10, -4,  3, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() >=  0x01def && x.lo() <=  0x01df3 && x.hi() >=  0x03b29 && x.hi() <=  0x03b2d);
    x = root(0x10, -3,  5, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() >=  0x06176 && x.lo() <=  0x0617a && x.hi() >=  0x0846b && x.hi() <=  0x0846f);
    x = root(0x10, -5,  3, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() >=  0x01181 && x.lo() <=  0x01185 && x.hi() >=  0x02904 && x.hi() <=  0x02908);
    x = root(0x10,  0,  1, Interval::Lohi { 0x30000,  0x50000}); assert(x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(0x10,  4,  4, Interval::Lohi {-0x30000,  0x50000}); assert(x.lo() == -0x30000 && x.hi() ==  0x50000);
    x = root(0x10,  4,  3, Interval::Lohi {-0x30000,  0x50000}); assert(x.lo() ==  0x00000 && x.hi() >=  0x88cc3 && x.hi() <=  0x88cc7);
    x = root(0x10,  4,  3, Interval::Lohi {-0x50000,  0x30000}); assert(x.lo() ==  0x00000 && x.hi() >=  0x88cc3 && x.hi() <=  0x88cc7);
    x = root(0x10,  3,  5, Interval::Lohi {-0x30000,  0x50000}); assert(x.lo() <= -0x1eee3 && x.lo() >= -0x1eee7 && x.hi() >=  0x2a062 && x.hi() <=  0x2a066);
    x = root(0x10,  5,  3, Interval::Lohi {-0x30000,  0x50000}); assert(x.lo() <= -0x63d7f && x.lo() >= -0x63d83 && x.hi() >=  0xe9ebc && x.hi() <=  0xe9ec0);
    x = root(0x10,  0,  1, Interval::Lohi {-0x30000,  0x50000}); assert(x.lo() ==  0x10000 && x.hi() ==  0x10000);
    {
        int n_thrown {0};
        try { x = root(0x10,  3,  4, Interval::Lohi {-0x30000,  0x50000}); } catch (const Interval::Forbidden_negative) { ++n_thrown; }
        try { x = root(0x10, -4,  4, Interval::Lohi {-0x30000,  0x50000}); } catch (const Interval::Division_by_zero  ) { ++n_thrown; }
        try { x = root(0x10, -3,  4, Interval::Lohi {-0x30000,  0x50000}); } catch (const Interval::Division_by_zero  ) { ++n_thrown; } catch (const Interval::Forbidden_negative) { ++n_thrown; }
        try { x = root(0x10, -4,  4, Interval::Lohi {-0x30000,  0x50000}); } catch (const Interval::Division_by_zero  ) { ++n_thrown; }
        try { x = root(0x10, -3,  5, Interval::Lohi {-0x30000,  0x50000}); } catch (const Interval::Division_by_zero  ) { ++n_thrown; }
        try { x = root(0x10, -5,  3, Interval::Lohi {-0x30000,  0x50000}); } catch (const Interval::Division_by_zero  ) { ++n_thrown; }
        assert (n_thrown == 6);
    }
    x = root(0x10,  4,  4, Interval::Lohi {-0x50000, -0x30000}); assert(x.hi() == -0x30000 && x.lo() == -0x50000);
    x = root(0x10,  4,  3, Interval::Lohi {-0x50000, -0x30000}); assert(x.lo() >=  0x453a4 && x.lo() <=  0x453a8 && x.hi() >=  0x88cc3 && x.hi() <=  0x88cc7);
    x = root(0x10,  3,  5, Interval::Lohi {-0x50000, -0x30000}); assert(x.hi() <= -0x1eee3 && x.hi() >= -0x1eee7 && x.lo() <= -0x2a062 && x.lo() >= -0x2a066);
    x = root(0x10,  5,  3, Interval::Lohi {-0x50000, -0x30000}); assert(x.hi() <= -0x63d7f && x.hi() >= -0x63d83 && x.lo() <= -0xe9ebc && x.lo() >= -0xe9ec0);
    x = root(0x10, -4,  4, Interval::Lohi {-0x50000, -0x30000}); assert(x.hi() <= -0x03331 && x.hi() >= -0x03335 && x.lo() <= -0x05553 && x.lo() >= -0x05557);
    x = root(0x10, -4,  3, Interval::Lohi {-0x50000, -0x30000}); assert(x.lo() >=  0x01def && x.lo() <=  0x01df3 && x.hi() >=  0x03b29 && x.hi() <=  0x03b2d);
    x = root(0x10, -3,  5, Interval::Lohi {-0x50000, -0x30000}); assert(x.hi() <= -0x06176 && x.hi() >= -0x0617a && x.lo() <= -0x0846b && x.lo() >= -0x0846f);
    x = root(0x10, -5,  3, Interval::Lohi {-0x50000, -0x30000}); assert(x.hi() <= -0x01181 && x.hi() >= -0x01185 && x.lo() <= -0x02904 && x.lo() >= -0x02908);
    x = root(0x10,  0,  1, Interval::Lohi {-0x50000, -0x30000}); assert(x.lo() ==  0x10000 && x.hi() ==  0x10000);
    {
        int n_thrown {0};
        try { x = root(0x10,  3,  4, Interval::Lohi {-0x50000, -0x30000}); } catch (const Interval::Forbidden_negative) { ++n_thrown; }
        try { x = root(0x10, -3,  4, Interval::Lohi {-0x50000, -0x30000}); } catch (const Interval::Forbidden_negative) { ++n_thrown; }
        assert (n_thrown == 2);
    }
    x = root(0x10,  3,  4, Interval::Lohi { 0x00000,  0x50000}); assert(x.lo() ==  0x00000 && x.hi() >=  0x357fb && x.hi() <=  0x357ff);
    x = root(0x10,  4,  4, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.lo() ==  0x30000 && x.hi() ==  0x50000);
    x = root(0x10,  3,  4, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.hi() <= -0x2478c && x.hi() >= -0x24790 && x.lo() <= -0x357fb && x.lo() >= -0x357ff);
    x = root(0x10,  4,  3, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.lo() >=  0x453a4 && x.lo() <=  0x453a8 && x.hi() >=  0x88cc3 && x.hi() <=  0x88cc7);
    x = root(0x10,  3,  5, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.lo() >=  0x1eee3 && x.lo() <=  0x1eee7 && x.hi() >=  0x2a062 && x.hi() <=  0x2a066);
    x = root(0x10,  5,  3, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.lo() >=  0x63d7f && x.lo() <=  0x63d83 && x.hi() >=  0xe9ebc && x.hi() <=  0xe9ec0);
    x = root(0x10, -4,  4, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.lo() >=  0x03331 && x.lo() <=  0x03335 && x.hi() >=  0x05553 && x.hi() <=  0x05557);
    x = root(0x10, -3,  4, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.hi() <= -0x04c8e && x.hi() >= -0x04c92 && x.lo() <= -0x0704c && x.lo() >= -0x07050);
    x = root(0x10, -4,  3, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.lo() >=  0x01def && x.lo() <=  0x01df3 && x.hi() >=  0x03b29 && x.hi() <=  0x03b2d);
    x = root(0x10, -3,  5, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.lo() >=  0x06176 && x.lo() <=  0x0617a && x.hi() >=  0x0846b && x.hi() <=  0x0846f);
    x = root(0x10, -5,  3, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.lo() >=  0x01181 && x.lo() <=  0x01185 && x.hi() >=  0x02904 && x.hi() <=  0x02908);
    x = root(0x10,  0,  1, Interval::Lohi { 0x30000,  0x50000}, true); assert(x.lo() ==  0x10000 && x.hi() ==  0x10000);
    x = root(0x10,  4,  4, Interval::Lohi {-0x30000,  0x50000}, true); assert(x.lo() == -0x30000 && x.hi() ==  0x50000);
    x = root(0x10,  4,  3, Interval::Lohi {-0x30000,  0x50000}, true); assert(x.lo() ==  0x00000 && x.hi() >=  0x88cc3 && x.hi() <=  0x88cc7);
    x = root(0x10,  4,  3, Interval::Lohi {-0x50000,  0x30000}, true); assert(x.lo() ==  0x00000 && x.hi() >=  0x88cc3 && x.hi() <=  0x88cc7);
    x = root(0x10,  3,  5, Interval::Lohi {-0x30000,  0x50000}, true); assert(x.lo() <= -0x1eee3 && x.lo() >= -0x1eee7 && x.hi() >=  0x2a062 && x.hi() <=  0x2a066);
    x = root(0x10,  5,  3, Interval::Lohi {-0x30000,  0x50000}, true); assert(x.lo() <= -0x63d7f && x.lo() >= -0x63d83 && x.hi() >=  0xe9ebc && x.hi() <=  0xe9ec0);
    x = root(0x10,  0,  1, Interval::Lohi {-0x30000,  0x50000}, true); assert(x.lo() ==  0x10000 && x.hi() ==  0x10000);
    {
        int n_thrown {0};
        try { x = root(0x10,  3,  4, Interval::Lohi {-0x30000,  0x50000}, true); } catch (const Interval::Forbidden_negative) { ++n_thrown; }
        try { x = root(0x10, -4,  4, Interval::Lohi {-0x30000,  0x50000}, true); } catch (const Interval::Division_by_zero  ) { ++n_thrown; }
        try { x = root(0x10, -3,  4, Interval::Lohi {-0x30000,  0x50000}, true); } catch (const Interval::Division_by_zero  ) { ++n_thrown; } catch (const Interval::Forbidden_negative) { ++n_thrown; }
        try { x = root(0x10, -4,  4, Interval::Lohi {-0x30000,  0x50000}, true); } catch (const Interval::Division_by_zero  ) { ++n_thrown; }
        try { x = root(0x10, -3,  5, Interval::Lohi {-0x30000,  0x50000}, true); } catch (const Interval::Division_by_zero  ) { ++n_thrown; }
        try { x = root(0x10, -5,  3, Interval::Lohi {-0x30000,  0x50000}, true); } catch (const Interval::Division_by_zero  ) { ++n_thrown; }
        assert (n_thrown == 6);
    }
    x = root(0x10,  4,  4, Interval::Lohi {-0x50000, -0x30000}, true); assert(x.hi() == -0x30000 && x.lo() == -0x50000);
    x = root(0x10,  4,  3, Interval::Lohi {-0x50000, -0x30000}, true); assert(x.lo() >=  0x453a4 && x.lo() <=  0x453a8 && x.hi() >=  0x88cc3 && x.hi() <=  0x88cc7);
    x = root(0x10,  3,  5, Interval::Lohi {-0x50000, -0x30000}, true); assert(x.hi() <= -0x1eee3 && x.hi() >= -0x1eee7 && x.lo() <= -0x2a062 && x.lo() >= -0x2a066);
    x = root(0x10,  5,  3, Interval::Lohi {-0x50000, -0x30000}, true); assert(x.hi() <= -0x63d7f && x.hi() >= -0x63d83 && x.lo() <= -0xe9ebc && x.lo() >= -0xe9ec0);
    x = root(0x10, -4,  4, Interval::Lohi {-0x50000, -0x30000}, true); assert(x.hi() <= -0x03331 && x.hi() >= -0x03335 && x.lo() <= -0x05553 && x.lo() >= -0x05557);
    x = root(0x10, -4,  3, Interval::Lohi {-0x50000, -0x30000}, true); assert(x.lo() >=  0x01def && x.lo() <=  0x01df3 && x.hi() >=  0x03b29 && x.hi() <=  0x03b2d);
    x = root(0x10, -3,  5, Interval::Lohi {-0x50000, -0x30000}, true); assert(x.hi() <= -0x06176 && x.hi() >= -0x0617a && x.lo() <= -0x0846b && x.lo() >= -0x0846f);
    x = root(0x10, -5,  3, Interval::Lohi {-0x50000, -0x30000}, true); assert(x.hi() <= -0x01181 && x.hi() >= -0x01185 && x.lo() <= -0x02904 && x.lo() >= -0x02908);
    x = root(0x10,  0,  1, Interval::Lohi {-0x50000, -0x30000}, true); assert(x.lo() ==  0x10000 && x.hi() ==  0x10000);
    {
        int n_thrown {0};
        try { x = root(0x10,  3,  4, Interval::Lohi {-0x50000, -0x30000}, true); } catch (const Interval::Forbidden_negative) { ++n_thrown; }
        try { x = root(0x10, -3,  4, Interval::Lohi {-0x50000, -0x30000}, true); } catch (const Interval::Forbidden_negative) { ++n_thrown; }
        assert (n_thrown == 2);
    }
    x = root(0x10,  3,  4, Interval::Lohi { 0x00000,  0x50000}, true); assert(x.hi() ==  0x00000 && x.lo() <= -0x357fb && x.lo() >= -0x357ff);
    x = root(0x10,  2,  3, Interval::Lohi {0x400000, 0x400000}); assert(x.lo() == 0x100000 && x.hi() == 0x100000);
    x = root(0x10,  2,  3, Interval::Lohi {0x400000, 0x400001}); assert(x.lo() == 0x100000 && x.hi() == 0x100001);
    x = root(0x10,  2,  3, Interval::Lohi {0x400001, 0x400001}); assert(x.lo() == 0x100000 && x.hi() == 0x100001);
    x = root(0x10,  4,  3, Interval::Lohi {0x400000, 0x400000}); assert(x.lo() ==0x1000000 && x.hi() ==0x1000000);
    x = root(0x10,  4,  3, Interval::Lohi {0x400000, 0x400001}); assert(x.lo() ==0x1000000 && x.hi() ==0x1000006);
    x = root(0x10,  4,  3, Interval::Lohi {0x400001, 0x400001}); assert(x.lo() ==0x1000005 && x.hi() ==0x1000006);

    return 0;

}

